using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Telerik.WebControls;
using Telerik.WebControls.Base.Calendar;

public partial class _Default : System.Web.UI.Page 
{
    int weekNumber
    {
        get
        {
            if (Session["WeekNumber"] == null)
            {
                Session["WeekNumber"] = 1;
            }
            return (int)Session["WeekNumber"];
        }
        set
        {
            Session["WeekNumber"] = value;
        }
    }

    DateTime lastWeekDay
    {
        get
        {
            if (Session["lastWeekDay"] == null)
            {
                Session["lastWeekDay"] = DateTime.MinValue;
            }
            return (DateTime)Session["lastWeekDay"];
        }
        set
        {
            Session["lastWeekDay"] = value;
        }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            DateTime monthStartDate = (RadCalendar1.CalendarView as MonthView).MonthStartDate;
            weekNumber = GetLastWeekDayWeekNumber(monthStartDate);
        }
    }
  
    protected void RadCalendar1_DayRender(object sender, Telerik.WebControls.Base.Calendar.Events.DayRenderEventArgs e)
    {
        if (e.Day.Date.DayOfWeek == System.DayOfWeek.Saturday)
        {
            if (GetWeekNumberFromDate(e.Day.Date) != weekNumber)
            {
                (e.Cell.Parent as TableRow).Style["display"] = "none";
            }
            else
            {
                lastWeekDay = e.Day.Date;
            }
        }
    }
    private int GetWeekNumberFromDate(DateTime date)
    {
        return
            RadCalendar1.Calendar.GetWeekOfYear(date, RadCalendar1.DateTimeFormat.CalendarWeekRule,
                                                RadCalendar1.DateTimeFormat.FirstDayOfWeek);
    }
    
    private int GetLastWeekDayWeekNumber(DateTime date)
    {
        int dayOfWeek = (int)date.DayOfWeek;
        return GetWeekNumberFromDate(date.AddDays(6 - dayOfWeek));
    }

    protected override void RaisePostBackEvent(IPostBackEventHandler sourceControl, string eventArgument)
    {
        //if the post back request is being made from navigation of the calendar instance 
        if ((sourceControl is RadCalendar) &&
            (eventArgument == "n:1" || eventArgument == ("n:" + RadCalendar1.FastNavigationStep)) ||
            (eventArgument == "n:-1" || eventArgument == ("n:-" + RadCalendar1.FastNavigationStep)))
        {
            int step = int.Parse(eventArgument.Split(':')[1]);
            weekNumber += step;
            if (weekNumber > 52) //should go to the next year weekNumber
                weekNumber = weekNumber - 52;
            else if (weekNumber < 1)//weekNumber is negative
                weekNumber = 52 + weekNumber; //should go the previous year weekNumber

            DateTime lastMonthViewDay = (RadCalendar1.CalendarView as MonthView).MonthEndDate;
            int lastMonthWeekDayWeekNumber = GetLastWeekDayWeekNumber(lastMonthViewDay);

            bool isNextMonthView = false;
            if (lastMonthWeekDayWeekNumber < weekNumber)
                isNextMonthView = GetLastWeekDayWeekNumber(lastWeekDay.AddDays(7 * step)) == weekNumber;

            DateTime firstMonthViewDay = (RadCalendar1.CalendarView as MonthView).MonthStartDate;
            int firstMonthWeekDayWeekNumber = GetLastWeekDayWeekNumber(firstMonthViewDay);
            bool isPreviousMonthView = false;
            if (firstMonthWeekDayWeekNumber > weekNumber)
                isPreviousMonthView = GetLastWeekDayWeekNumber(lastWeekDay.AddDays(7 * step)) == weekNumber; //step is negative in this case

            if (!isNextMonthView && !isPreviousMonthView)
                eventArgument = "n:0";
            else
            {
                if (step > 0)
                    eventArgument = "n:1"; //can not move more than 3 weeks more/less which is always 1 month
                else eventArgument = "n:-1";
            }
        }
        base.RaisePostBackEvent(sourceControl, eventArgument);
    }
}
